<template>
  <div class="card bg-secondary bg-opacity-10">
    <div class="card-header">
      <div class="row">
        <time>{{ creationDate }}</time>
        <span v-if="Boolean(link.comment)">{{ link.comment }}</span>
      </div>
    </div>
    <div class="card-body row align-items-center justify-content-between">
      <div class="col-12 col-lg-9 mb-3 mb-sm-3 mb-lg-0">
        <div class="row text-truncate">
          <strong class="col-auto">{{ linkUrlValue }} -></strong>
          <!--          <span></span>-->
          <span class="col-6 text-truncate text-truncate-none">
            {{ link.redirectUrl }}
          </span>
        </div>
      </div>
      <div class="col-12 col-lg-3">
        <Link class="me-2" :to="`tracker/${linkUrlValue}`">Статистика</Link>
        <Button
          v-if="!link.isArchived"
          @click="onSendToArchive"
          :loading="isLoading"
          >В архив</Button
        >
      </div>
    </div>
  </div>
</template>

<script setup>
import { computed } from "vue";
import Button from "@/components/Button.vue";
import Link from "@/components/Link.vue";
import { dateFormat } from "@/modules/Tracker/utils";
import { useLinkStore } from "@/modules/Tracker/stores";
import { useLoading } from "@/composables";

const props = defineProps({
  link: { type: Object, default: () => ({}), required: true },
});

const creationDate = dateFormat(props.link.createdOn);
const { isLoading, setLoading } = useLoading();

const linkUrlValue = computed(() => `${props.link.domain}/${props.link.uid}`);
const store = useLinkStore();

const { setLinkToArchive } = store;

const onSendToArchive = async () => {
  setLoading(true);
  await setLinkToArchive(props.link.uid);
  setLoading(false);
};
</script>
